#!/usr/bin/php
<?php

########################################
## Config ##############################
########################################

$max_temp_variation = 1; # Celcius degree(s)
$temper_exec = '/Users/gb/bin/TEMPer';
$calibration_offset = -9;

########################################
########################################
$data_file = "/Users/gb/Documents/.temps.dat";

if ($argc > 1 && $argv[1] == 'get') {
	$latest_temps = get_latest_temps_array();
	$temp = -1;
	if (count($latest_temps) > 0) {
		$temp = round(array_sum($latest_temps) / count($latest_temps), 2);
	}
	echo "$temp\n";
	exit(0);
}

exec("for pid in `ps | grep what_temperature.php | grep -v grep | awk '{print $1}'`; do if [ ! \"\$pid\" == \"" . getmypid() . "\" ]; then kill \$pid; fi; done");

$start = time();
$temps = array();
while (TRUE) {
	$now = time();
	$temp = exec($temper_exec);
	$temp += $calibration_offset;
	if (count($temps) > 0) {
		$diff = $temps[count($temps)-1] - $temp;
		if ($diff < 0) {
			$diff = $diff * -1;
		}
		if ($diff >= $max_temp_variation) {
			if ($now - $start >= 50) {
				break;
			}
			continue;
		}
	} else if ($temp < 15 || $temp > 40) {
		sleep(1);
		if ($now - $start >= 50) {
			break;
		}
		continue;
	}
	$temps[] = $temp;

	sleep(1);

	if ($now - $start >= 50) {
		break;
	}
}
if (count($temps) == 0) {
	exit(-1);
}
$temp = round(array_sum($temps) / count($temps), 2);

function get_latest_temps_array() {
	global $data_file;
	$file_content = @file_get_contents($data_file);
	if (!empty($file_content)) {
		$latest_temps = unserialize($file_content);
	} else {
		$latest_temps = array();
	}
	return $latest_temps;
}

$latest_temps = get_latest_temps_array();

if (count($latest_temps) > 0) {
	$diff = $latest_temps[count($latest_temps)-1] - $temp;
	if ($diff < 0) {
		$diff = $diff * -1;
	}
	if ($diff >= $max_temp_variation) {
		exit(-1);
	}
}

$latest_temps[] = $temp;
if (count($latest_temps) > 5) {
	array_shift($latest_temps);
}

file_put_contents($data_file, serialize($latest_temps));
