#!/usr/bin/php
<?php

########################################
## Config ##############################
########################################

# Device ID
$device_id = '0c.04.27';

# How many hours after turning on/off the device manually should it be protected from automatic programming?
$manual_override_safety = 3;

# How many hours before a program should we prepare for it?
# This will allow us to reach the program setting at the time specified, instead of having the AC start working at that time.
$hours_buildup = 3;

# AC performance, in °C per minute?
# Example: 5.5°C / 443 minutes
# $ac_performance = 5.5 / 443;
$ac_performance = 12/1000;

# Start AC when the current temperature is 1°C (or more) above the requested temperature
$start_above = 1;

# Stop AC when the current temperature is below the requested temperature
$stop_below = 0;

mysql_connect('localhost', 'automate', 'automate456');
mysql_select_db('automate');

$data_file = '/var/hda/web-apps/automate/.automate_program.dat';

########################################
########################################

$result = mysql_query("SELECT value FROM settings WHERE name = 'active_program_no'")
	or die("Can't select active_program_no setting: " . mysql_error() . "\n");
if ($row = mysql_fetch_object($result)) {
	$active_program_no = (int) $row->value;
} else {
	$active_program_no = 1;
}
echo "\nactive_program_no = $active_program_no";

# Last program
$current_program = get_program('back');
#var_dump($current_program);

# Next program
$upcoming_program = get_program('forward');
#var_dump($upcoming_program);

# Current temperature
$result = mysql_query("SELECT temperature FROM TEMPer.temperatures WHERE who = '3e' AND `when` > DATE_SUB(NOW(), INTERVAL 1 HOUR) ORDER BY `when` DESC LIMIT 1")
	or die("Can't select active_program_no setting: " . mysql_error() . "\n");
if (mysql_num_rows($result) == 0) {
	echo "No temperature reading in the last hour... Aborting.\n";
	exit(1);
}
$row = mysql_fetch_object($result);

$current_temp = (float) $row->temperature;

#echo "-A-";
if ($upcoming_program->timestamp > time() + $hours_buildup*60*60 || strpos($upcoming_program->what, 'auto=') === FALSE) {
#	echo "-B-";
	$active_program = $current_program;
} else {
#	echo "-C-";
	if ($current_temp <= $upcoming_program->temp - $stop_below) {
		# We're already below the next program temperature; so keep working on the previous program.
		#		echo "-D-";
		$active_program = $current_program;
	} else {
#		echo "-E-";
		# How much time (minutes) do we have left until the next event?
		$time_left = ($upcoming_program->timestamp - time()) / 60;

		# Can we reach the programmed temp. in time?
		$temp_difference = $current_temp - $upcoming_program->temp;
		
		echo "\ntime_left: $time_left; temp_difference: $temp_difference; upcoming_program->temp: $upcoming_program->temp; current_temp: $current_temp";
		
		if ($time_left > 0 && $temp_difference / $time_left < $ac_performance) {
			# Yes; don't activate next program just yet.
#			echo "-F-";
			$active_program = $current_program;
		} else {
			# No; start next program now.
#			echo "-G-";
			$active_program = $upcoming_program;
		}
	}
}
echo "\n" . date('Y-m-d H:i:s') . "\n";
echo "current: " . $current_temp . "; program: " . $active_program->what . ' @ ' . $active_program->datetime . "\n";

if (strpos($active_program->what, 'auto=') === 0 && $current_temp >= $active_program->temp + $start_above) {
	# Start AC
#	echo "-H-";
	$state = 'on';
	reset_off_datafile();
}
else if ($current_temp <= @$active_program->temp - $stop_below || $active_program->what == 'off') {
	# Stop AC
#	echo "-J-";
	if (should_be_off()) {
#		echo "-K-";
		$state = 'off';
	}
}
if (!isset($state)) {
	echo "state is empty... Aborting.\n";
	exit(0);
}

# Check if the AC is 'protected' (i.e. has been turned on or off manually in the last X hours)
$query = sprintf("SELECT * FROM event_logs WHERE type = 'manual' AND `when` > '%s'",
	date('Y-m-d H:i:s', strtotime('-' . $manual_override_safety . ' hours'))
);
$result = mysql_query($query)
	or die("Can't select event_logs: " . mysql_error() . "\n");
if (mysql_num_rows($result) != 0) {
	echo "Protected... Aborting.\n";
	exit(0);
} else {
	# Not protected; execute the command
	$command = 'sudo /usr/local/bin/icmd '.$device_id.' ' . ($state == 'on' ? '18 255' : '20 00') . ' 2>&1 | grep -v "Timeout waiting for PLC to echo data"';
	echo "$command\n";
	exec($command);
	log_event($active_program->what . ' @ ' . $active_program->datetime . ' => ' . $state);
}

function get_program($direction) {
	global $active_program_no;
	$dow = array('Su','M','Tu','W','Th','F','Sa');
	
	$now = time();
	$time = date('H:i:s');
	do {
		$today_index = date('w', $now);
		$today = $dow[$today_index];

		$query = "SELECT time, what FROM program WHERE day LIKE '%$today%' AND time " . ($direction == 'back' ? '<' : '>=') . " '$time' AND enabled = 'true' AND program_no IN (0, $active_program_no) ORDER BY time " . ($direction == 'back' ? 'DESC' : 'ASC') . ", program_no DESC LIMIT 1";
		$result = mysql_query($query)
			or die("Can't select programs: " . mysql_error() . "\n");

		$time = $direction == 'back' ? '23:59:59' : '00:00:00';
		$now = strtotime(($direction == 'back' ? '-' : '+') . '1 day', $now);
	} while (mysql_num_rows($result) == 0);

	if (mysql_num_rows($result) > 0 && $program = mysql_fetch_object($result)) {
		$program->date = date('Y-m-d', strtotime(($direction == 'back' ? '+' : '-') . '1 day', $now));
		$program->datetime = $program->date . ' ' . $program->time;
		$program->timestamp = strtotime($program->datetime);
		if (strpos($program->what, 'auto=') === 0) {
			$program->temp = (int) substr($program->what, 5);
		}
		return $program;
	}
}

function log_event($what, $type='automatic') {
	# Don't insert 'duplicates'
	$query = sprintf("SELECT what, type FROM event_logs ORDER BY `when` DESC LIMIT 1",
		mysql_escape_string($type)
	);
	$result = mysql_query($query)
		or die("Can't select event_logs: " . mysql_error() . "\n");
	if (mysql_num_rows($result) > 0) {
		$row = mysql_fetch_object($result);
		if (strpos($row->what, $what) !== FALSE && $row->type == $type) {
			return;
		}
	}
	
	global $current_temp;
	mysql_query(sprintf("INSERT INTO event_logs (what, type) VALUES ('%s', '%s')", 
		mysql_escape_string("current: " . round($current_temp, 1) . "; program: " . $what), 
		mysql_escape_string($type)
	));
}

function should_be_off() {
	global $data_file;
	$file_content = @file_get_contents($data_file);
	if (empty($file_content)) {
		$num_consecutive_off = 0;
	} else {
		$num_consecutive_off = unserialize($file_content);
	}
	$num_consecutive_off++;
	file_put_contents($data_file, serialize($num_consecutive_off));
	
	return $num_consecutive_off > 3;
}

function reset_off_datafile() {
	global $data_file;
	$num_consecutive_off = 0;
	file_put_contents($data_file, serialize($num_consecutive_off));
}
