/*
 * $RCSfile: device_control.h,v $  $Revision: 1.5 $  $Name:  $
 * $Id: device_control.h,v 1.5 2006/10/04 05:21:44 bpaauwe Exp $
 * $Author: bpaauwe $
 * $Date: 2006/10/04 05:21:44 $
 * ----------------------------------------------------------------------------
 *
 *  Copyright (c) Bob Paauwe (2006)
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 *  more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * ----------------------------------------------------------------------------
 *
 *  Description:
 *    Header file for Device Control dialog box.
 * ----------------------------------------------------------------------------
 */
#ifndef _DEVICE_CONTROL_H
#define _DEVICE_CONTROL_H

#include <gtk/gtk.h>
#include "scenes.h"

extern ilib_t *iplc; /* device handle */
extern unsigned char need_to_save;

extern scene_t *scene_list;
extern device_t device_array[2000];
extern int last_device;

GtkWidget *dc_dialog;
GtkWidget *dc_selector;
GtkWidget *dc_device_type;
GtkWidget *dc_status;
GtkWidget *dc_on_level;
GtkWidget *dc_dimmer;
GtkWidget *dc_up;
GtkWidget *dc_down;
GtkWidget *dc_local_level;
GtkWidget *dc_local_ramp;

void on_device_control_activate(GtkWidget *widget, gpointer user_data);
void on_dc_selector_changed(GtkWidget *widget, gpointer user_data);
void on_dc_set_level_clicked(GtkWidget *widget, gpointer user_data);
void on_dc_off_clicked(GtkWidget *widget, gpointer user_data);
void on_dc_dimmer_value_changed(GtkWidget *widget, gpointer user_data);
void on_closebutton2_clicked(GtkWidget *widget, gpointer user_data);
void on_dc_dimmer_move_slider(GtkWidget *widget, gpointer user_data);
void on_dc_up_clicked(GtkWidget *widget, gpointer user_data);
void on_dc_down_clicked(GtkWidget *widget, gpointer user_data);
void on_dc_up_released(GtkWidget *widget, gpointer user_data);
void on_dc_down_released(GtkWidget *widget, gpointer user_data);
void on_dc_apply_clicked(GtkWidget *widget, gpointer user_data);

#endif
